# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

# This is a perl hash ref.  The three toplevel keys are:
#     uml - these are the starting UML parameters, which may be
#         overridden by ~/.uml_profile, the command line, a test, or
#	  a filesystem.
#     tests - test-specific parameters : each key within tests is a test
#         name, which is its location under the 'tests' directory, minus the
#         '.pl' ; the value is test-dependent.
#     filesystems - root filesystem-specific information : each key is a 
#	  filesystem name ; the value is a hash ref containing (key, value) 
#	  pairs which will override the values in uml.  Typically, this will be
#         the shell prompt regex, and maybe the login name and password.

# ~/.umltest has the same format and whatever values are there will override
# the values here.

# More values can be specified on the test.pl command line as 
# '-c key1/key2/name=value', which will set ->{key1}->{key2}->{name} to 
# value.  E.g. '-c defaults/kernel=~/uml/linux' will change the kernel
# to be used for this run.

# The possible keys and values for defaults are:
#    ubd - a hash ref whose keys are device numbers and values are filesystem 
#        names
#    mem - a string containing a memory size specification
#    con* - the key is a console specification and the value is a host channel
#        specification
#    ssl* - ditto for serial lines
#    umid - the instance name
#    kernel - path name of the UML binary to be used
#    login_prompt - the login prompt to wait for
#    login - the user name to log in as
#    password_prompt and password - ditto for the password
#    prompt - a regex that matches the shell's toplevel prompt

# The tests and the test-specific parameters are
#    filesystems/boot_filesystems
#        filesystems - a string naming a filesystem to boot or an array ref
#            containing a set of strings naming filesystems.  They may be
#            bzipped, in which case they will be uncompressed automatically.
#            They should not specify a COW file over the filesystem.
#    signals/vfork - no parameters

{
    uml => {
	kernel => "/usr/bin/linux",
	login_prompt => "login:",
	login => "root",
	password_prompt => "Password:",
	password => "root",
	mem => "128M"
    }
};
