#!/bin/bash

# This is meant to be run from cron.  It contains the settings for a 
# particular site and it constructs the command line of new_patch.sh
# from them.  new_patch.sh detects new UML patches and runs the test suite
# on them.
#
# The crontab I'm using is this:
#

# MAILTO=""
#
# 0 * * * *       bash $HOME/tests/run_suite.sh
#

# MAILTO is nulled out because you really don't want mail every hour telling
# you it didn't do anything.

TESTS=$HOME/tests
MIRROR_ROOT=/mnt/mirrors/pub
KERNEL=$MIRROR_ROOT/mirrors/kernel-rsync/pub/linux/kernel/v2.4
UML=$MIRROR_ROOT/uml
MAILTO=jdike@karaya.com

bash $TESTS/new_patch.sh $KERNEL $UML $TESTS $TESTS/summary && \
    mail -s "`date` : Test suite run of latest patch" $MAILTO < \
	$TESTS/summary
