# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Testlib;
use UML::Test;

use strict;

my $prog = '
#include <unistd.h>
#include <stdio.h>

int main()
{
        printf("%d\n", getpid());
}
';

sub interact {
    my $expect = shift;
    my $time = shift;

    my $commands = [ "break main", "run" ];
    my (undef, $stopped) = one_interact($expect, $time, $commands, 
					"(gdb) ", @_);
    $stopped =~ /Program exited/ and die "gdb missed the breakpoint\n";
    $stopped !~ /Breakpoint/ and 
	die "Unexpected gdb output : '$stopped'\n";
}

sub run {
    my $uml = shift;

    my $exe = compile($uml, $prog, "-g -static");
    gdb($uml, $exe, \&interact);
}

UML::Test->new(state => "up", run => \&run);
