# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Testlib;
use UML::Test;

use strict;

my $prog = '
#include <stdio.h>

int main(int argc, char **argv)
{
        printf("Here I am\n");
        while(1) sleep(30);
}
';

sub interact {
    my $expect = shift;
    my $time = shift;

    my $commands = [ "break main", "run", "i reg" ];
    my (undef, undef, $regs) = one_interact($expect, $time, $commands, 
					    "(gdb) ", @_);
    if($regs =~ /^(cwd|fctrl)/m){
	my $reg = $1;
	my $set_get = [ "set \$$reg=0xdeadbeef", "p/x \$$reg" ];
	my (undef, $deadbeef) = one_interact($expect, $time, $set_get,
					     "(gdb) ", @_);
	$deadbeef !~ /deadbeef/ and 
	    die "Setting $reg to 0xdeadbeef didn't work\n";
    }
    else {
	die "No sign of FP registers from 'i reg'\n";
    }
}

sub run {
    my $uml = shift;

    my $exe = compile($uml, $prog, "-g");
    gdb($uml, "$exe", \&interact);
}

UML::Test->new(state => "up", run => \&run);
