# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

sub run {
    my $uml = shift;

    my $output = $uml->command("strace ls -l /");
    my @lines = split("\n", $output);
    @lines < 50 and die "Too little strace output\n";

    $output = $uml->command("strace -f bash -c 'ls; ls'");
    @lines = split("\n", $output);
    for my $line (@lines){
	$line =~ /^\[pid\s+\d+\]/ and return;
    }
    die "No sign of subprocesses in 'strace -f' output\n";
}

UML::Test->new(state => "up", run => \&run);
