# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Testlib;
use UML::Test;

use strict;

sub run {
    my $uml = shift;
    my $swap = "swap";
    my $megs = 128;
    my $swap_cmd = "cat /proc/meminfo | grep Swap:|awk '{print \$2}'";

    my $before;
    my $after;
    my $swap;
    eval {
	($before) = run_exit_0($uml, $swap_cmd);
	$swap = add_swap($uml, $megs);
	($after) = run_exit_0($uml, $swap_cmd);
    };
    my $err = $@;

    eval { remove_swap($uml, $swap); };
    $err and die $err;

    $after = ($after + 1024 * 1024) & ~(1024 * 1024 - 1);
    if($megs * 1024 * 1024 != $after - $before){
	die "Wanted " . $megs * 1024 * 1024 . " more swap, got " . 
	    ($after - $before) . "\n";
    }
}

UML::Test->new(state => "up", run => \&run);
