# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Testlib;
use UML::Test;

use strict;

my $hog ='
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

int main(int argc, char **argv)
{
        void *ptr;

        ptr = malloc(20 * 1024 * 1024);
        if(ptr == NULL){
                perror("malloc");
                exit(1);
        }
	memset(ptr, 0xff, 20 * 1024 * 1024);
	printf("All set\n");
	while(1) pause();
}
';

sub hog_interact {
    my $expect = shift;
    my $time = shift;

    my ($pos, $err, $match, $before, $after) = 
	$expect->expect($time, "All set", @_);
    $pos != 1 and return($pos - 1, $err, $match, $before, $after);

    $expect->print($time, chr(26));
    return($expect->expect($time, @_));
}

sub run {
    my $uml = shift;
    my $log = shift;
    my $name = shift;
    my $config = shift;

    $uml->args(mem => "16M");
    $uml->boot($log->logger());
    my $swap1 = add_swap($uml, 16);

    $uml->command("cd /tmp");
    my $exe = compile($uml, $hog);
    $uml->command($exe, \&hog_interact);
    $uml->command("bg");

    my $swap2 = add_swap($uml, 16);
    remove_swap($uml, $swap1);

    $uml->halt();
}

UML::Test->new(state => "down", run => \&run);
