# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

my $restart = '
#include <stdio.h>
#include <signal.h>

int saw_ctrl_c = 0;

void handler(int sig)
{
    if(saw_ctrl_c) exit(0);
    saw_ctrl_c = 1;
    printf("SIGINT\n");
}

int main(int argc, char **argv)
{
    struct sigaction sa;
    char c;
      
    sa.sa_handler = handler;
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = SA_RESTART;
    if(sigaction(SIGINT, &sa, NULL) < 0){
        perror("sigaction");
        exit(1);
    }
    read(0, &c, sizeof(c));
    return(0);
}
';

sub newline {
    my $expect = shift;
    my $time = shift;

    $expect->print("\n");
    return($expect->expect($time, @_));
}

sub ctrl_c_newline {
    my $expect = shift;
    my $time = shift;

    $expect->print(chr(3));
    my ($pos, $err, $match, $before, $after) = 
	$expect->expect($time, "SIGINT", @_);
    $pos != 1 and return($pos - 1, $err, $match, $before, $after);
    
    $expect->print("\n");
    return($expect->expect($time, @_));
}

sub ctrl_c_ctrl_c {
    my $expect = shift;
    my $time = shift;

    $expect->print(chr(3));
    my ($pos, $err, $match, $before, $after) = 
	$expect->expect($time, "SIGINT", @_);
    $pos != 1 and return($pos - 1, $err, $match, $before, $after);

    $expect->print(chr(3));
    return($expect->expect($time, @_));    
}

sub run {
    my $uml = shift;

    compile_run_interact_exit_0($uml, $restart, \&newline);
    compile_run_interact_exit_0($uml, $restart, \&ctrl_c_newline);
    compile_run_interact_exit_0($uml, $restart, \&ctrl_c_ctrl_c);
}

UML::Test->new(state => "up", run => \&run);
