# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

my $restore = '
#include <stdio.h>
#include <signal.h>

void success(void)
{
    exit(0);
}

void handler(int sig, struct sigcontext sc)
{
    sc.eip = (unsigned long) success;
}

int main(int argc, char **argv)
{
    signal(SIGUSR1, handler);
    kill(getpid(), SIGUSR1);
    printf("Failed to reset IP in handler\n");
    exit(1);
}
';

sub run {
    my $uml = shift;

    compile_run_exit_0($uml, $restore);
}

UML::Test->new(state => "up", run => \&run);
