# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

my $siginfo = '
#include <stdio.h>
#include <signal.h>

void handler(int sig, siginfo_t *info, void *unused)
{
  if((sig != SIGSEGV) || (info->si_signo != SIGSEGV) ||
     (info->si_code != SEGV_MAPERR) || (info->si_addr != (void *) 0xdeadbeef))
    exit(1);
  exit(0);
}

int main(int argc, char **argv)
{
  struct sigaction sa;

  sa.sa_sigaction = handler;
  sigemptyset(&sa.sa_mask);
  sa.sa_flags = SA_SIGINFO;
  if(sigaction(SIGSEGV, &sa, NULL) < 0){
    perror("sigaction");
    exit(1);
  }
  *((int *) 0xdeadbeef) = 0;
}
';

sub run {
    my $uml = shift;

    compile_run_exit_0($uml, $siginfo);
}

UML::Test->new(state => "up", run => \&run);
