# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

my $siginfo_restore = '
#include <stdio.h>
#include <signal.h>

int count = 0;

void handler(int sig, siginfo_t *info, void *unused)
{
  count++;
}

int main(int argc, char **argv)
{
  struct sigaction sa;

  sa.sa_sigaction = handler;
  sigemptyset(&sa.sa_mask);
  sa.sa_flags = SA_SIGINFO;
  if(sigaction(SIGUSR1, &sa, NULL) < 0){
    perror("sigaction");
    exit(1);
  }
  kill(getpid(), SIGUSR1);
  kill(getpid(), SIGUSR1);
  exit(count != 2);
}
';

sub run {
    my $uml = shift;

    compile_run_exit_0($uml, $siginfo_restore);
}

UML::Test->new(state => "up", run => \&run);
