# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

my $vfork = '
#include <stdio.h>
#include <signal.h>

void handler(int sig)
{
        printf("in handler\n");
}

int main(int argc, char **argv)
{
        int pid;

        signal(SIGCHLD, handler);
        pid = vfork();
        if(pid == 0){
                exit(1);
        }
        exit(0);
}
';

sub run {
    my $uml = shift;

    compile_run_exit_0($uml, $vfork);
}

UML::Test->new(state => "up", run => \&run);
