# 
# Copyright (C) 2002 Jeff Dike (jdike@karaya.com)
# Licensed under the GPL
#

use UML::Test;
use UML::Testlib;

use strict;

sub run {
    my $uml = shift;
    my $log = shift;
    my $name = shift;
    my $config = shift;
    my $pool = $config->test_option("kernel_pool");

    !defined($pool) and die "'kernel_pool' not defined - skipping test\n";

    my $dev = $uml->add($pool);
    run_exit_0($uml, 
	       "mkdir linux",
	       "mount /dev/ubd/$dev linux");
    eval { run_exit_0($uml, 
		      "cd linux",
		      "make mrproper",
		      "make oldconfig",
		      "make vmlinux");
    };
    my $build_err = $@;

    eval {
	run_exit_0($uml, "cd ..", "umount /dev/ubd/$dev");
	$uml->remove($dev);
    };
    my $clean_err = $@;
    $build_err and die $build_err;
    $clean_err and die $clean_err;
}

UML::Test->new(state => "up", run => \&run);
